searchNodes=[{"doc":"Extends the Ecto DSL for easily working with TimescaleDB . Already using Ecto and Postgres ? Great, you're all set to start working with time-series data. Features Easy creation of hypertables in Ecto Migrations Leverage TimescaleDB hyperfunctions right inside your Ecto queries Configure table compression policies Adding the TimescaleDB extension Make sure your database has Timescale correctly installed Create a new Ecto migration Call the create_timescaledb_extension/0 and drop_timescaledb_extension/0 in your migration E.g. defmodule MyApp.Repo.Migrations.SetupTimescale do use Ecto.Migration import Timescale.Migration def up do create_timescaledb_extension ( ) end def down do drop_timescaledb_extension ( ) end end Installation If available in Hex , the package can be installed by adding timescale to your list of dependencies in mix.exs : def deps do [ { :timescale , &quot;~&gt; 0.1.0&quot; } ] end Installing Postgres / TimescaleDB on MacOS There are many ways to install PostgreSQL locally, including Postgres.app , Docker , and building locally. Below is how to install through Homebrew First, install Postgres $ brew install postgresql $ sudo chown $(whoami) /usr/local/var/postgres $ initdb /usrl/local/var/postgres $ createuser -s postgres $ createdb Make Postgres a service that is started automatically $ brew services start postgresql Then install TimescaleDB. For more information about installing TimescaleDB on MacOS, see the official documentation . $ brew tap timescale/tap $ brew install timescaledb # Add the following to `/opt/homebrew/var/postgres/postgresql.conf` shared_preload_libraries = &#39;timescaledb&#39;","ref":"Timescale.html","title":"Timescale","type":"module"},{"doc":"Timescale hyperfunctions are a specialized set of functions that allow you to analyze time-series data. You can use hyperfunctions to analyze anything you have stored as time-series data, including IoT devices, IT systems, marketing analytics, user behavior, financial metrics, and cryptocurrency. Documentation Approximate Row Count Documentation Timescale offers a hyperfunction, approximate_row_count , for retrieving the approximate row count of hypertables. This hyperfunction may be useful for tables with a large number of rows, where the exact number is not needed. As Ecto does not support raw SQL through the Ecto.Query API, we have chosen not to directly support approximate_row_count , for it be an inconsistent API. If this is a useful feature to your application, you can use the following code: defmacro approximate_row_count ( relation ) do query = &quot;SELECT approximate_row_count($1::TEXT)&quot; quote do { :ok , % Postgrex.Result { rows : [ [ num_rows ] ] } } = Ecto.Adapters.SQL . query ( MyApp.MyRepo , unquote ( query ) , [ unquote ( relation ) ] ) num_rows end end","ref":"Timescale.Hyperfunctions.html","title":"Timescale.Hyperfunctions","type":"module"},{"doc":"The first aggregate allows you to get the value of one column as ordered by another. For example, first(temperature, time) returns the earliest temperature value based on time within an aggregate group. Documentation","ref":"Timescale.Hyperfunctions.html#first/2","title":"Timescale.Hyperfunctions.first/2","type":"macro"},{"doc":"The histogram function represents the distribution of a set of values as an array of equal-width buckets. It partitions the dataset into a specified number of buckets (nbuckets) ranging from the inputted min and max values. The return value is an array containing nbuckets+2 buckets, with the middle nbuckets bins for values in the stated range, the first bucket at the head of the array for values under the lower min bound, and the last bucket for values greater than or equal to the max bound. Each bucket is inclusive on its lower bound, and exclusive on its upper bound. Therefore, values equal to the min are included in the bucket starting with min, but values equal to the max are in the last bucket. Documentation","ref":"Timescale.Hyperfunctions.html#histogram/4","title":"Timescale.Hyperfunctions.histogram/4","type":"macro"},{"doc":"The last aggregate allows you to get the value of one column as ordered by another. For example, last(temperature, time) returns the latest temperature value based on time within an aggregate group. Documentation","ref":"Timescale.Hyperfunctions.html#last/2","title":"Timescale.Hyperfunctions.last/2","type":"macro"},{"doc":"Allows you to aggregate results into arbitrary time buckets. You can group by seconds, minutes, hours, days and also weeks. For example, time_bucket(timestamp, &quot;5 minutes&quot;) would allow you to group results into 5 minute buckets. This function also accepts the following optional parameters (passed in as a keyword list): :offset - The time interval used to offset all of the timebuckets by. (Postgres type: &quot;INTERVAL&quot;) :origin - The timestamp used to align all of the time buckets. (Postgres type: &quot;TIMESTAMP&quot;) Documentation","ref":"Timescale.Hyperfunctions.html#time_bucket/3","title":"Timescale.Hyperfunctions.time_bucket/3","type":"macro"},{"doc":"Works similar to time_bucket/2 but also activates gap-filling for the interval inferred by the where clause of the query. Documentation","ref":"Timescale.Hyperfunctions.html#time_bucket_gapfill/2","title":"Timescale.Hyperfunctions.time_bucket_gapfill/2","type":"macro"},{"doc":"Some hyperfunctions are included in the default TimescaleDB product. For additional hyperfunctions, you need to install the TimescaleDB Toolkit PostgreSQL extension. All of the hyperfunctions in this module require the Toolkit to be installed, or else you will encounter an error. For installation instructions, see the Timescale Docs Install the Postgres extension with Timescale.Migration.create_timescaledb_toolkit_extension/0","ref":"Timescale.Hyperfunctions.Toolkit.html","title":"Timescale.Hyperfunctions.Toolkit","type":"module"},{"doc":"This function transforms pre-aggregated candlestick data into a candlestick aggregate object. This object contains the data in the correct form to use with the accessors and rollups in this function group. If you're starting with raw tick data rather than candlestick data, use candlestick_agg instead. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#candlestick/6","title":"Timescale.Hyperfunctions.Toolkit.candlestick/6","type":"macro"},{"doc":"Perform analysis of financial asset data. These specialized hyperfunctions make it easier to write financial analysis queries that involve candlestick data. They help you answer questions such as: What are the opening and closing prices of these stocks? When did the highest price occur for this stock? This function group uses the two-step aggregation pattern. In addition to the usual aggregate function, candlestick_agg, it also includes the pseudo-aggregate function candlestick . candlestick_agg produces a candlestick aggregate from raw tick data, which can then be used with the accessor and rollup functions in this group. candlestick takes pre-aggregated data and transforms it into the same format that candlestick_agg produces. This allows you to use the accessors and rollups with existing candlestick data. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#candlestick_agg/3","title":"Timescale.Hyperfunctions.Toolkit.candlestick_agg/3","type":"macro"},{"doc":"Get the closing price from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#close/1","title":"Timescale.Hyperfunctions.Toolkit.close/1","type":"macro"},{"doc":"Get the timestamp corresponding to the close time from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#close_time/1","title":"Timescale.Hyperfunctions.Toolkit.close_time/1","type":"macro"},{"doc":"Get the high price from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#high/1","title":"Timescale.Hyperfunctions.Toolkit.high/1","type":"macro"},{"doc":"Get the timestamp corresponding to the high time from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#high_time/1","title":"Timescale.Hyperfunctions.Toolkit.high_time/1","type":"macro"},{"doc":"Get the low price from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#low/1","title":"Timescale.Hyperfunctions.Toolkit.low/1","type":"macro"},{"doc":"Get the timestamp corresponding to the low time from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#low_time/1","title":"Timescale.Hyperfunctions.Toolkit.low_time/1","type":"macro"},{"doc":"Get the opening price from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#open/1","title":"Timescale.Hyperfunctions.Toolkit.open/1","type":"macro"},{"doc":"Get the timestamp corresponding to the open time from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#open_time/1","title":"Timescale.Hyperfunctions.Toolkit.open_time/1","type":"macro"},{"doc":"Combine multiple intermediate candlestick aggregates, produced by candlestick_agg or candlestick , into a single intermediate candlestick aggregate. For example, you can use rollup to combine candlestick aggregates from 15-minute buckets into daily buckets. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#rollup/1","title":"Timescale.Hyperfunctions.Toolkit.rollup/1","type":"macro"},{"doc":"Get the total volume from a candlestick aggregate. Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#volume/1","title":"Timescale.Hyperfunctions.Toolkit.volume/1","type":"macro"},{"doc":"Get the Volume Weighted Average Price from a candlestick aggregate. For Candlesticks constructed from data that is already aggregated, the Volume Weighted Average Price is calculated using the typical price for each period (where the typical price refers to the arithmetic mean of the high, low, and closing prices). Documentation","ref":"Timescale.Hyperfunctions.Toolkit.html#vwap/1","title":"Timescale.Hyperfunctions.Toolkit.vwap/1","type":"macro"},{"doc":"This module provides helpers for installing TimescaleDB, as well as creating, modifying, and configuring Timescale resources.","ref":"Timescale.Migration.html","title":"Timescale.Migration","type":"module"},{"doc":"Adds a compression policy to a hypertable using the add_compression_policy function","ref":"Timescale.Migration.html#add_compression_policy/3","title":"Timescale.Migration.add_compression_policy/3","type":"macro"},{"doc":"Creates a new hypertable in an Ecto Migration. create_hypertable ( :conditions , :time )","ref":"Timescale.Migration.html#create_hypertable/3","title":"Timescale.Migration.create_hypertable/3","type":"macro"},{"doc":"Adds TimescaleDB as a Postgres extension","ref":"Timescale.Migration.html#create_timescaledb_extension/0","title":"Timescale.Migration.create_timescaledb_extension/0","type":"macro"},{"doc":"Adds the TimescaleDB toolkit as a Postgres Extension","ref":"Timescale.Migration.html#create_timescaledb_toolkit_extension/0","title":"Timescale.Migration.create_timescaledb_toolkit_extension/0","type":"macro"},{"doc":"Disables compression on an existing hypertable. Note that chunks must be decompressed before its called See the ALTER TABLE (Compression) documentation","ref":"Timescale.Migration.html#disable_hypertable_compression/1","title":"Timescale.Migration.disable_hypertable_compression/1","type":"macro"},{"doc":"Drops TimescaleDB as a Postgres extension","ref":"Timescale.Migration.html#drop_timescaledb_extension/0","title":"Timescale.Migration.drop_timescaledb_extension/0","type":"macro"},{"doc":"Drops the TimescaleDB toolkit as a Postgres Extension","ref":"Timescale.Migration.html#drop_timescaledb_toolkit_extension/0","title":"Timescale.Migration.drop_timescaledb_toolkit_extension/0","type":"macro"},{"doc":"Enables compression on an existing hypertable See the ALTER TABLE (Compression) documentation Required arguments :segment_by - Column list on which to key the compressed segments","ref":"Timescale.Migration.html#enable_hypertable_compression/2","title":"Timescale.Migration.enable_hypertable_compression/2","type":"macro"},{"doc":"Removes a compression policy from a hypertable using the remove_compression_policy function","ref":"Timescale.Migration.html#remove_compression_policy/2","title":"Timescale.Migration.remove_compression_policy/2","type":"macro"},{"doc":"Updates the existing TimescaleDB toolkit extension","ref":"Timescale.Migration.html#update_timescaledb_toolkit_extension/0","title":"Timescale.Migration.update_timescaledb_toolkit_extension/0","type":"macro"},{"doc":"Raised at compilation time when the migration contains optional TimescaleDB arguments that are not supported by the provided function.","ref":"Timescale.MigrationArgError.html","title":"Timescale.MigrationArgError","type":"exception"},{"doc":"Raised at compilation time when the query contains optional TimescaleDB arguments that are not supported by the provided function.","ref":"Timescale.OptionalArgError.html","title":"Timescale.OptionalArgError","type":"exception"},{"doc":"Mix . install ( [ { :timescale , path : &quot;../timescale&quot; } , { :kino_db , &quot;~&gt; 0.2.0&quot; } , { :jason , &quot;~&gt; 1.4&quot; } , { :postgrex , &quot;~&gt; 0.16.5&quot; } , { :kino_ecto , git : &quot;https://github.com/vorce/kino_ecto&quot; } ] ) # Add https://github.com/vorce/kino_ecto","ref":"intro.html","title":"Intro to Timescale","type":"extras"},{"doc":"Let's learn about using the timescale Elixir library for TimescaleDB . For our example, let's imagine we're building a fitness application that tracks your heart rate through a wearable device. Our application will receive (literal) heartbeats from the wearable device at varying intervals that we will record into the database.","ref":"intro.html#building-a-health-tracker","title":"Intro to Timescale - Building a health tracker","type":"extras"},{"doc":"First and foremost, please ensure you have TimescaleDB installed on your machine using the installation guide . To go through these examples, you'll need the Timescale Toolkit installed on your machine as well. The best way to install is with Docker, or if you're brave, build from source. Once Postgres/Timescale is up in running, you'll also need to set up secrets for connecting to a database. This will also require creating a Postgres database. Try the following commands in your shell: $ psql -c &#39;create database timescale_fitness&#39; You'll also need to set the following secrets in Livebook POSTGRES_HOST - postgres hostname to connect to (default localhost ) POSTGRES_USER - postgres username to connect with (default postgres ) POSTGRES_PASS - postgres password to connect with (default postgres ) POSTGRES_DATABASE - database name (default timescale_fitness ) defmodule Fitness.Repo do use Ecto.Repo , otp_app : :fitness , adapter : Ecto.Adapters.Postgres def init ( _type , config ) do { :ok , Keyword . merge ( config , migration_lock : :pg_advisory_lock , hostname : System . get_env ( &quot;LB_POSTGRES_HOST&quot; , &quot;localhost&quot; ) , port : 5432 , username : System . get_env ( &quot;LB_POSTGRES_USER&quot; , &quot;postgres&quot; ) , password : System . get_env ( &quot;LB_POSTGRES_PASSWORD&quot; , &quot;postgres&quot; ) , # If using Fly, enable IPv6 below # socket_options: [:inet6], database : System . get_env ( &quot;LB_POSTGRES_DATABASE&quot; , &quot;timescale_fitness&quot; ) ) } end # Helper function for LiveBook demonstrations. def migrate ( { num , migration } , direction ) when is_atom ( migration ) do { :ok , _ , _ } = Ecto.Migrator . with_repo ( __MODULE__ , fn repo -&gt; Ecto.Migrator . run ( repo , [ { num , migration } ] , direction , all : true ) end ) &quot;Successfully Migrated \#{ inspect ( migration ) } &quot; end end alias Fitness.Repo import Ecto.Query , except : [ first : 2 , last : 2 ] { :ok , repo_pid } = Kino . start_child ( Repo ) opts = [ hostname : &quot;localhost&quot; , port : 5432 , username : &quot;postgres&quot; , password : &quot;postgres&quot; , database : &quot;timescale_fitness&quot; ] { :ok , conn } = Kino . start_child ( { Postgrex , opts } )","ref":"intro.html#setting-up-the-repo","title":"Intro to Timescale - Setting up the Repo","type":"extras"},{"doc":"defmodule Fitness.Repo.Migrations.CreateHeartbeat do use Ecto.Migration import Timescale.Migration def up do create_timescaledb_extension ( ) create_if_not_exists table ( :users ) do add ( :fullname , :string ) end create_if_not_exists ( unique_index ( :users , [ :fullname ] ) ) create_if_not_exists table ( :heartbeats , primary_key : false ) do add ( :timestamp , :naive_datetime_usec , null : false ) add ( :user_id , references ( :users ) , null : false ) end create_hypertable ( :heartbeats , :timestamp ) end def down do drop ( table ( &quot;heartbeats&quot; ) , mode : :cascade ) drop ( table ( &quot;users&quot; ) , mode : :cascade ) drop_timescaledb_extension ( ) end end Repo . migrate ( { 0 , Fitness.Repo.Migrations.CreateHeartbeat } , :up )","ref":"intro.html#creating-our-hypertable-migration","title":"Intro to Timescale - Creating our hypertable migration","type":"extras"},{"doc":"To facilitate our example, let's create three users who are tracking their heartbeats. users = [ %{ fullname : &quot;Dave Lucia&quot; } , %{ fullname : &quot;Alex Koutmos&quot; } , %{ fullname : &quot;Peter Ullrich&quot; } ] Repo . insert_all ( &quot;users&quot; , users , on_conflict : :nothing ) query = from ( u in &quot;users&quot; , order_by : [ desc : u . fullname ] , select : %{ id : u . id , fullname : u . fullname } ) [ %{ id : peter_id } = peter , %{ id : dave_id } = dave , %{ id : alex_id } = alex ] = Repo . all ( query ) Next, we've built a little module to help us simulate heartbeats for an entire day. defmodule Fitness.Generator do @ms_in_day :timer . hours ( 24 ) @doc &quot;&quot;&quot; Given a date, will generate a list of heartbeats for the day, represented as a list of maps with a `timestamp` field &quot;&quot;&quot; @spec generate_heartbeats ( %{ id : integer ( ) } , Date . t ( ) ) :: list ( %{ timestamp : NaiveDateTime . t ( ) } ) def generate_heartbeats ( user , day ) do do_generate_heartbeats ( user , [ ] , NaiveDateTime . new! ( day , ~T[00:00:00.000] ) , 0 ) end defp do_generate_heartbeats ( user , heartbeats , day , ms ) do # keep it between 60-200 beats per minute next = floor ( :timer . minutes ( 1 ) / Enum . random ( 60 .. 200 ) ) + ms if next &lt; @ms_in_day do heartbeat = %{ timestamp : NaiveDateTime . add ( day , next , :millisecond ) , user_id : user . id } do_generate_heartbeats ( user , [ heartbeat | heartbeats ] , day , next ) else Enum . reverse ( heartbeats ) end end end # TODO try method in https://klotzandrew.com/blog/postgres-passing-65535-parameter-limit batch_insert = fn heartbeats -&gt; heartbeats |&gt; Enum . chunk_every ( 100 ) |&gt; Enum . map ( fn chunk -&gt; Repo . insert_all ( &quot;heartbeats&quot; , chunk ) end ) end","ref":"intro.html#generating-mock-data","title":"Intro to Timescale - Generating mock data","type":"extras"},{"doc":"Next, we generate heartbeats for one user, and batch insert them into the database. batch_insert . ( Fitness.Generator . generate_heartbeats ( alex , ~D[2022-09-22] ) )","ref":"intro.html#generate-small-dataset","title":"Intro to Timescale - Generate small dataset","type":"extras"},{"doc":"Now that we have a dataset generated, let's try some queries using Timescale hyperfunctions . Let's start with the basics, and try to get the first and last values in our timeseries, using the first and last hyperfunctions. import Timescale.Hyperfunctions Repo . all ( from ( h in &quot;heartbeats&quot; , where : h . user_id == ^ alex_id , select : { first ( h . timestamp , h . timestamp ) , last ( h . timestamp , h . timestamp ) } ) ) Ok, so not so interesting, but we can validate that our data starts roughly at the beginning of today and ends towards midnight. For more of a challenge, let's use the time_bucket hyperfunction to calculate average BPM for each hour. First, let's explore how the time_bucket hyperfunction works. Repo . all ( from ( h in &quot;heartbeats&quot; , where : h . user_id == ^ alex_id , select : { h . timestamp , time_bucket ( h . timestamp , &quot;1 second&quot; ) } , limit : 5 ) ) The first item in each tuple is the actual timestamp of the heartbeat, down to the microsecond. The second item is the result of time_bucket/2 on the timestamp, bucketed down to the nearest second. time_bucket/2 acts like the floor/1 math function, and as we'll see in a moment, enables further aggregation over time-series. Repo . all ( from ( h in &quot;heartbeats&quot; , where : h . user_id == ^ alex_id , group_by : selected_as ( :minute ) , select : %{ minute : selected_as ( time_bucket ( h . timestamp , &quot;1 minute&quot; ) , :minute ) , bpm : count ( h ) } , limit : 5 ) )","ref":"intro.html#querying-with-timescale","title":"Intro to Timescale - Querying with Timescale","type":"extras"},{"doc":"So far, we've only taken a look at a relatively small dataset. Repo . one ( from ( h in &quot;heartbeats&quot; , select : count ( h ) ) ) Let's make this way more interesting by generating a months worth of heartbeats for our second user. As shown above, that should put us around 5 million rows of data. Go grab a soda, as this is gonna take a little while to execute. for date &lt;- Date . range ( ~D[2022-10-01] , ~D[2022-10-31] ) do batch_insert . ( Fitness.Generator . generate_heartbeats ( dave , date ) ) end result3 = Postgrex . query! ( conn , &quot;select * from approximate_row_count(&#39;heartbeats&#39;);&quot; , [ ] ) Now that we have a large dataset, let's retry our previous queries and see how they perform. result4 = Postgrex . query! ( conn , &quot;explain analyze select first(h.timestamp, h.timestamp), last(h.timestamp, h.timestamp) from heartbeats as h where user_id = 1;&quot; , [ ] ) Wow! They're still lightning fast. Timescale changes the query plan to make use of the hypertable architecture. Each chunk of our hypertable is aware of the time column, and can easily eliminate rows in bulk from our query plan.","ref":"intro.html#performance-with-large-datasets","title":"Intro to Timescale - Performance with large datasets","type":"extras"},{"doc":"One of the most compelling features of TimescaleDB is its ability to compress data. While data storage may be relatively cheap, the rate at which time-series data grows changes the equation a bit! result5 = Postgrex . query! ( conn , &quot;select pg_size_pretty(hypertable_size(&#39;heartbeats&#39;)) as heartbeats_size&quot; , [ ] ) defmodule Fitness.Repo.Migrations.CompressHeartbeats do use Ecto.Migration import Timescale.Migration def up do enable_hypertable_compression ( :heartbeats , segment_by : :user_id ) add_compression_policy ( :heartbeats , &quot;7 days&quot; ) end def down do execute ( &quot;SELECT decompress_chunk(i, true) from show_chunks(&#39;heartbeats&#39;) i;&quot; ) flush ( ) remove_compression_policy ( :test_hypertable , if_exists : true ) disable_hypertable_compression ( :heartbeats ) end end Repo . migrate ( { 1 , Fitness.Repo.Migrations.CompressHeartbeats } , :up ) Now that we've compressed the table, we should observe that its size as been dramatically reduced. For some datasets, its common to see compression ratios of up to 96%. result6 = Postgrex . query! ( conn , &quot;select pg_size_pretty(hypertable_size(&#39;heartbeats&#39;)) as heartbeats_size&quot; , [ ] )","ref":"intro.html#compression","title":"Intro to Timescale - Compression","type":"extras"},{"doc":"As should be clear by now, aggregating data over time is extremely common when working with time-series data. Often, you'll want to compute aggregations across your dataset, grouped by various attributes such as your users, location, and of course, time. TimescaleDB has a feature called Continuous Aggregates that dramatically improves the performance of expensive aggregations. It accomplishes this with some clever usage of materialized views , triggers , and hypertables, to produce views on data that update in real-time and query instaneously. Let's build a continuous aggregate for calcuating the min and max daily BPM for each user. result7 = Postgrex . query! ( conn , &quot;&quot;&quot; CREATE MATERIALIZED VIEW heartbeats_minutely WITH (timescaledb.continuous) AS SELECT time_bucket(&#39;1 minute&#39;, h.timestamp) as minute, count(h) as bpm, user_id FROM heartbeats as h GROUP BY minute, user_id &quot;&quot;&quot; , [ ] ) result8 = Postgrex . query! ( conn , &quot;SELECT add_retention_policy(&#39;heartbeats&#39;, INTERVAL &#39;1 year&#39;);&quot; , [ ] )","ref":"intro.html#continuous-aggregates","title":"Intro to Timescale - Continuous Aggregates","type":"extras"},{"doc":"Warning: this section requires the TimescaleDB Toolkit to be installed, which may require building from source. defmodule Fitness.Repo.Migrations.AddTimescaleToolkit do use Ecto.Migration import Timescale.Migration def up do create_timescaledb_toolkit_extension ( ) end def down do drop_timescaledb_toolkit_extension ( ) end end Repo . migrate ( { 3 , Fitness.Repo.Migrations.AddTimescaleToolkit } , :up ) With any system, there are opportunities for the system to go down. This could be due to a datacenter outage, global DNS being attacked, or simply an application configuration mishap. Regardless, it is possible for gaps in the collection of our data, which poses problems for calculations and aggregations. Luckily, TimescaleDB provides hyperfunctions for gapfilling and interpoltion so smooth over these gaps. Let's add some heartbeats in for another user every second, skipping over a few. Repo . insert_all ( &quot;heartbeats&quot; , [ %{ timestamp : ~N[2022-11-01 09:00:00] , user_id : peter_id } , %{ timestamp : ~N[2022-11-01 09:00:01] , user_id : peter_id } , # No heartbeat at 9:00:02 %{ timestamp : ~N[2022-11-01 09:00:03] , user_id : peter_id } , # No heartbeat at 9:00:04 %{ timestamp : ~N[2022-11-01 09:00:05] , user_id : peter_id } ] ) Now we've got 4 heartbeats, with two missing at seconds 2 and 4. We can use the time_bucket_gapfill/2 function to fill in heartbeats. Repo . all ( from ( h in &quot;heartbeats&quot; , where : h . user_id == ^ peter_id , select : %{ second : selected_as ( time_bucket_gapfill ( h . timestamp , &quot;1 second&quot; ) , :second ) , user_id : h . user_id } , where : h . timestamp &gt;= ^ ~N[2022-11-01 09:00:00] and h . timestamp &lt;= ^ ~N[2022-11-01 09:00:05] , group_by : [ selected_as ( :second ) , h . user_id ] ) )","ref":"intro.html#filling-gaps-in-time-series","title":"Intro to Timescale - Filling gaps in time-series","type":"extras"}]